//
// eibdaemon.cpp
// begin: 25.03.2003
// Lehrig
//
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include "rlbussignaldatabase.h"
#include "rlsocket.h"
#include "rlserial.h"

rlSerial *tty = NULL;
#define SERIAL_PORT "/dev/cua0"

//------ some helper functions -------------------------------------------
void hex2group(const char *line, char *group)
{
  char *cptr;
  int  val,hh,m,uuu;

  *group = '\0';
  cptr = strchr(line,'>');
  if(cptr == NULL) return;
  cptr++;
  sscanf(cptr,"%x",&val);
  uuu = val & 0x0ff;
  m   = (val/256) & 0x07;
  hh  = (val/256) / 8;
  sprintf(group,"%d/%d/%03d",hh,m,uuu);
}

void binex(char *line)
{
  int i;

  i = 0;
  while(line[i] >= ' ') i++;
  line[i] = '\0';
}

// ------ our receiver ---------------------------------------------------
void *rec(void *arg)
{
  char line[1024],buf[64],*cptr;
  int ret;
  rlBussignalDatabase db;
  while((ret = db.openDatabase("automation","bus")) != 0)
  {
    sleep(3);
  }
  //printf("openDatabase ret=%d\n",ret);

  while(1)
  {
    if(arg == NULL) return NULL;
    if(tty->select(1000) == 1)
    {
      ret = tty->readLine((unsigned char *) line,sizeof(line)-1);
      printf("readLine ret=%d line=%s\n",ret,line);
      if(strchr(line,'>') != NULL && strchr(line,'=') != NULL)
      {
        hex2group(line,buf);
        cptr = strchr(line,'=');
        if(cptr != NULL)
        {
          cptr++;
          binex(cptr);
          printf("%s %s\n",buf,cptr);
          ret = db.writeDatabaseString(buf,cptr);
        }
      }
    }
  }
}

// ------- our main -------------------------------------------------------
int main(int ac, char **av)
{
  int s;
  char line[4096],terminator[4],*cptr;
  FILE *fp;
  rlSocket socket("localhost",5500,0);
  rlThread receiver;
  tty = new rlSerial;
  while(tty->openDevice(SERIAL_PORT,B38400) != 0)
  {
    sleep(3); // wait for getty to become idle
  }
  sleep(3);
  tty->closeDevice();
  sleep(3);
  while(tty->openDevice(SERIAL_PORT,B38400) != 0)
  {
    sleep(3); // wait for getty to become idle
  }

  terminator[0] = 0x0d;
  terminator[1] = 0x0a;
  terminator[3] = '\0';

  if(ac == 1)
  {
    receiver.create(rec,NULL);
  }
  else if(ac == 2) // copy inifile to tty
  {
    receiver.create(rec,NULL);
    fp = fopen(av[1],"r");
    if(fp == NULL)
    {
      printf("could not open %s\n",av[1]);
      return -1;
    }
    while(fgets(line,sizeof(line)-1,fp) != NULL)
    {
      cptr = strchr(line,'\n');
      if(cptr != NULL)
      {
        *cptr = '\0';
        strcat(line,terminator);
      }
      tty->writeBlock((unsigned char *) line,strlen(line));
    }
    fclose(fp);
  }
  else
  {
    printf("usage: eibdaemon inifile\n");
    return -1;
  }

  line[0] = '?';
  line[1] = 'V';
  line[2] = '\0';
  strcat(line,terminator);
  tty->writeBlock((unsigned char *) line,strlen(line));

  while(1)
  {
    s = socket.connect();
    if(s > 0)
    {
      socket.readStr(line,sizeof(line)-1);
      strcat(line,terminator);
      //printf("writeBlock=%s\n", line);
      tty->writeBlock((unsigned char *) line,strlen(line));
      socket.disconnect();
    }
    else break;
  }
  return 0;
}
