#include <stdio.h>
#include <string.h>
#include "rlserial.h"

void hex2group(const char *line, char *group)
{
  char *cptr;
  int  val,hh,m,uuu;

  *group = '\0';
  cptr = strchr(line,'>');
  if(cptr == NULL) return;
  cptr++;
  sscanf(cptr,"%x",&val);
  uuu = val & 0x0ff;
  m   = (val/256) & 0x07;
  hh  = (val/256) / 8;
  sprintf(group,"%d/%d/%03d",hh,m,uuu);
}

void ourprint(const char *line)
{
  char buf[32];
  int i;

  for(i=0; line[i] != '\0'; i++)
  {
    if     (line[i] >= ' ')  printf("%c",line[i]);
    //else if(line[i] == '\n') printf("\n");
    else                     printf("'%02x'",line[i]);
  }
  hex2group(line,buf);
  printf(" %s\n",buf);
}

int main(int ac, char **av)
{
  unsigned char line[1024];
  char buf[4];
  int ret;

  rlSerial *tty = new rlSerial();
  ret = tty->openDevice("/dev/cua0",B38400);
  printf("openDevice ret=%d\n",ret);

  if(ac <= 1)
  {
    line[0] = '?';
    line[1] = 'P';
    line[2] = 0x0d;
    line[3] = 0x0a;
    line[4] = '\0';
  }
  else
  {
    buf[0] = 0x0d; buf[1] = 0x0a; buf[2] = '\0';
    strcpy((char *) line, av[1]);
    strcat((char *) line, buf);
  }
  ret = tty->writeBlock(line,strlen((char *)line));
  printf("writeBlock ret=%d\n",ret);
  while(tty->select(1000) != 0 || 1)
  {
    ret = tty->readLine(line,sizeof(line)-1);
    ourprint((const char *) line);
    //printf("%s\n",line);
    if(ret == -1) break;
  }

  tty->closeDevice();
  delete tty;
  return 0;
}


