//
// 3964R daemon template                                 (C) R. Lehrig 2004
//
//
// Attention: this program must be run as super user
//

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "rl3964r.h"
#include "rlsharedmemory.h"
#include "rlmailbox.h"

#ifdef unix
#define SERIAL_DEVICE   "/dev/ttyS0"                                   // todo: specify name of serial device
rl3964R        connection(rl3964R::lowPriority);
rlSharedMemory shm("/srv/automation/shm/si3964r.shm",128*sizeof(int));  // todo: specify name of shm and size
rlMailbox      mbx("/srv/automation/mbx/si3964r.mbx");                  // todo: specify name of mbx
#endif

void readCallback(const unsigned char *buf, int len)
{
  char buf2[512];
  int i;
  memcpy(buf2,(const unsigned char *) &buf[0],len);  
  for (i=0;i<len;printf("i=%2d Value= %8x \n",i++,buf2[i]));
  
//  strncpy(buf2,(const char *) buf, len);
//  memcpy(buf2,(const unsigned char *) buf,len);
//  buf2[len] = '\0';
//  printf("Länge=%d readCallback:%s\n",len,buf2);
  shm.write(0,buf,len);
}

int main()
{
  int len,first,toggle;
  unsigned char line[1024];
  unsigned char str3964DBr[50];
  unsigned char str3964MBr[50];
  unsigned char str3964DBs[100];
  unsigned char str3964MBs[100];
  
  //In der SPS muss nur send-all und receive-all
  //für die CP525 Schnittstelle aktiviert werden
  //dann läuft die Kommunikation
  
  //holen von SPS
  str3964DBr[0]=0x00; //Muss nach HB CP525 0x00 sein
  str3964DBr[1]=0x00; // ""     "
  str3964DBr[2]=0x45; //Befehl Daten holen von SPS
  str3964DBr[3]='D'; //Kennung DB=0x44, M=0x4D, E=0x45?? , A=0x41??
  str3964DBr[4]=0x64; //DB Nr nur bei Kennung DB sonst 0x00
  str3964DBr[5]=0x00; //Startadresse
  str3964DBr[6]=0x00; //Länge Teil 1
  str3964DBr[7]=0x08; //Länge Teil 2
  str3964DBr[8]=0xff; //Koppelmerker Byte-Adr. (ohne = 0xFF)
  str3964DBr[9]=0xff; //Koppelmerker Bit-Adr. 0-7 (ohne=0xFF) 
  str3964DBr[10]='\0';  

  // senden an SPS
  str3964DBs[0]=0x00;
  str3964DBs[1]=0x00;
  str3964DBs[2]=0x41; //Befehl Daten senden an SPS
  str3964DBs[3]='D';
  str3964DBs[4]=0x64;
  str3964DBs[5]=0x02; // Schreiben ab DW2
  str3964DBs[6]=0x00;
  str3964DBs[7]=0x08;
  str3964DBs[8]=0xff;
  str3964DBs[9]=0xff;  
  str3964DBs[10]=0x11;  //DL2
  str3964DBs[11]=0x11;  //DR2
  str3964DBs[12]=0x12;  //DL3
  str3964DBs[13]=0x13;  //DR3
  str3964DBs[14]=0x14;  
  str3964DBs[15]=0x15;  
  str3964DBs[16]=0x16;  
  str3964DBs[17]=0x17;  
  str3964DBs[18]=0x18;  
  str3964DBs[19]=0x19;  
  str3964DBs[20]=0x1a;  
  str3964DBs[21]=0x1b;  
  str3964DBs[22]=0x1c;  
  str3964DBs[23]=0x1d;  
  str3964DBs[24]=0x1e;  //DL9
  str3964DBs[25]=0x1f;  //DR9
  str3964DBs[26]='\0';  

  //holen von SPS
  str3964MBr[0]=0x00; //Muss nach HB CP525 0x00 sein
  str3964MBr[1]=0x00; // ""     "
  str3964MBr[2]=0x45; //Befehl Daten holen von SPS
  str3964MBr[3]='M'; //Kennung DB=0x44, M=0x4D, E=0x45?? , A=0x41??
  str3964MBr[4]=0x00; //DB Nr nur bei Kennung DB sonst 0x00
  str3964MBr[5]=0x00; //Startadresse
  str3964MBr[6]=0x00; //Länge Teil 1
  str3964MBr[7]=0x40; //Länge Teil 2
  str3964MBr[8]=0xff; //Koppelmerker Byte-Adr. (ohne = 0xFF)
  str3964MBr[9]=0xff; //Koppelmerker Bit-Adr. 0-7 (ohne=0xFF) 
  str3964MBr[10]='\0';  

  // senden an SPS
  str3964MBs[0]=0x00;
  str3964MBs[1]=0x00;
  str3964MBs[2]=0x41; //Befehl Daten senden an SPS
  str3964MBs[3]='M';
  str3964MBs[4]=0x00;
  str3964MBs[5]=0x7F; // Schreiben ab DW2
  str3964MBs[6]=0x00;
  str3964MBs[7]=0x08;
  str3964MBs[8]=0xff;
  str3964MBs[9]=0xff;  
  str3964MBs[10]=0x11;  //MB2
  str3964MBs[11]=0x11;  //MB3
  str3964MBs[12]=0x12;  //MB4
  str3964MBs[13]=0x13;  //MB5
  str3964MBs[14]=0x14;  
  str3964MBs[15]=0x15;  
  str3964MBs[16]=0x16;  
  str3964MBs[17]=0x17;  
  str3964MBs[18]=0x18;  
  str3964MBs[19]=0x19;  
  str3964MBs[20]=0x1a;  
  str3964MBs[21]=0x1b;  
  str3964MBs[22]=0x1c;  
  str3964MBs[23]=0x1d;  
  str3964MBs[24]=0x1e;  //DL9
  str3964MBs[25]=0x1f;  //DR9
  str3964MBs[26]='\0';  
//  connection.debug = 1;
  connection.setReadCallback(readCallback);
  first = 1;
  toggle = 0;
  while(connection.open(SERIAL_DEVICE,B9600) < 0) // todo: specify serial parameters
  {
    if(first==1) printf("could not open serial device %s\n",SERIAL_DEVICE);
    first = 0;
    rlsleep(1000);
  }
  printf("\nstarting\n");

  while(1)
  {


    line[0] = '\0';
//    printf("line=");
//    scanf("%s",line);
//    len = strlen((const char *) str3964);
    //len = mbx.read(line,sizeof(line)-1);
    if(toggle == 0)
    {
	len = 10; //Das bestimmen der Länge ist noch ein Probelm
	printf("\nwill lesen 8-Worte (16-Byte) %d\n",len);
	connection.write((const unsigned char *) str3964DBr, len);
	toggle++;
    }
    else if (toggle == 1)
    {
	len = 26; //Das bestimmen der Länge ist noch ein Probelm
	printf("\nwill schreiben 8-Worte (16-Byte) %d\n",len);
//	str3964DBs[11]++;
	connection.write((const unsigned char *) str3964DBs, len);
	toggle++;
    }
    else if (toggle == 2)
    {
	len = 10; //Das bestimmen der Länge ist noch ein Probelm
	printf("\nwill lesen Merker 4-Worte (8-Byte) %d\n",len);
	connection.write((const unsigned char *) str3964MBr, len);
	toggle++;
    }
    else if (toggle == 3)
    {
	len = 26; //Das bestimmen der Länge ist noch ein Probelm
	printf("\nwill schreiben Merker 4-Worte (8-Byte) %d\n",len);
//	str3964MBs[11]++;
	connection.write((const unsigned char *) str3964MBs, len);
	toggle = 0;
    }
    
    rlsleep(500);  
    if (toggle == 0) return 0;
  }

  return 0;
}
